# coding: utf8
from microbit import *

from math import log as ln

#----- VARIABLES ---------------------------------------------

Rserie = 47000 # valeur Résistance entre A0 et GND

# caractérisation de la thermistance de 47k
A = 0.0009131577435290704 # coefficients Steinhart-Hart de la thermistance de 47k
B = 0.0002144210475986645 # doc technique ou calcul à partir de 3 mesures
C = 1.0773792283999106e-07

#---calcul de la température avec la relation de Steinhart-Hart----
def Thermistor(Nmes) :
  Resistance = Nmes*Rserie/(1024-Nmes)
  Temp = ln(Resistance); # sauver le log de la résistance mesurée
  Temp = 1 / (A + (B * Temp) + (C * Temp * Temp * Temp))
  Temp = Temp - 273.15  # Kelvin -> Celsius
  return Temp



#--------------- BOUCLE PRINCIPALE -----------------------------

while True:
    lecture=pin2.read_analog() # Lecture de la valeur de la CTN
    print(lecture)
    Celsius = Thermistor(lecture) # Conversion de la valeur lue en température
    print(str(round(Celsius)) + '  C')
    sleep(1000);
