# Ecrit ton programme ici ;-)
from microbit import *
from machine import time_pulse_us

def mesure_distance():
    """ Calcule la vitesse du son en m/s
   distance est exprimée en cm """

    # envoie une impulsion de 10 µs sur la pin2 pour démarrer une salve US #
    pin1.write_digital(1)
    sleep(0.01) # signal pendant 10 ms
    pin1.write_digital(0)
    # fin de l'impulsion

    pin2.read_digital() # configuration de pin2 en INPUT
    duree = time_pulse_us(pin2, 1) # attend que pin2 passe à 1 puis renvoie la durée en µs pendant laquelle pin2 reste à 1
    #d=(34000*t/100000)/2=17/1000*t (= t/58.8235)
    d= duree/58.8235;
    #vitesse = 2 * distance / (duree/1000000) # duree est en µs (+ aller retour) : vitesse en cm/s
    #vitesse = round(vitesse/100) # conversion en m/s (arrondie au m/s)
    return d

#DISTANCE = 50 # distance utilisée pour mesurer la vitesse du son, exprimée en cm !

while True:
    if button_a.was_pressed():
        distance = mesure_distance()
        print(distance) # retour REPL dans la console de l'éditeur
        display.show("d="+str(distance)+" cm", delay=500, loop=True, wait=False)