//----- VARIABLES ---------------------------------------------
int CTN = A0; // Sonde de température CTN entre A0 et 5V
float Rserie = 47000; // valeur Résistance entre A0 et GND

// caractérisation de la thermistance de 47k
float A = 0.0009131577435290704; // coefficients Steinhart-Hart de la thermistance de 47k
float B = 0.0002144210475986645; // doc technique ou calcul à partir de 3 mesures
float C = 1.0773792283999106e-07;

//---calcul de la température avec la relation de Steinhart-Hart----
float Thermistor(int Nmes) {
  long Resistance;
  float Temp; // Dual-Purpose variable to save space.
  Resistance = Nmes*47000/(1024-Nmes);
  Temp = log(Resistance); // sauver le log de la résistance mesurée
  Temp = 1 / (A + (B * Temp) + (C * Temp * Temp * Temp));
  Temp = Temp - 273.15;  // Kelvin -> Celsius
  return Temp;
}


void setup(void) {
    Serial.begin(9600);
}
//--------------- BOUCLE PRINCIPALE -----------------------------

void loop() {
int LECTURE = analogRead(CTN); // Lecture de la valeur de la CTN
Serial.println(LECTURE);
float Celsius = Thermistor(LECTURE); // Conversion de la valeur lue en température
Serial.println(Celsius);
delay(1000);
}   
